(*
        SpaceSweeper Level Creator
        GUI to level creation

        Author: Piotr Skowronek, pskowronek@adfinem.net
        Written in: 1997
        Licence: LGPL
 *)

program Gra_w_rozdzielczosci_320x200x256;
(*{$I-,R-,G+,S-,D+,Q-,V-}*)
{$I-,R+,G+,S+,D+,Q-}
{$M 50000,10000,650000}
uses DOS,SINCOS,MOUSE,READDAT,WRITEDAT,TYPES,MISC, KEYBOARD;

const
     BETA_test    =  True;
     BETA_dir     =  '';

     xp           =  84;
     xk           =  320-8;
     yp           =  0;
     yk           =  200;
     Font1_name   =  'FONTS#1.FON';
     Font2_name   =  'FONTS#2.FON';
     ResourceName = 'game.dat';


type virtual_bufor = array[0..199+4,0..319] of byte; { Ekran roboczy }

      T_Button = object
                   xp,yp,xk,yk : word;
                   title       : string;
                   run         : procedure;
                   Is_Out      : boolean;  { Ozn czy wcisniety. (redraw use it) }
                   constructor Init(xpos,ypos: word; text: string; func: pointer);
                   function  Pressed(xm,ym: word): boolean;
                   function  Is_on_button(xm,ym: word): boolean;
                   procedure Button_In;
                   procedure Button_Out;
                   procedure Button_ReDraw;
                 end;

      T_Scroll = object(T_button)
                   constructor Init(xpos,ypos: word; text: string; func: pointer);
                   function  Pressed(xm,ym: word): boolean;
                 end;

(*********** Z M I E N N E
 ***********)
     var  virtual_screen  : ^virtual_bufor;      { Ekran roboczy          }
          i,j             : word;                { Dla ptli              }
          oldexitproc     : pointer;
          HEAP_state      : pointer;
          EXE_path        : string[50];
          xm,ym,st,tm     : word;
          ch              : word;
          tlo             : T_BMP_Sprite;
          stng            : string;
          oldsize         : word;
          xo,yo           : word;
          Button_Undo,Button_Cls,
          Button_save,Button_load,Button_new,Button_quit,
          Button_pgup,Button_pgdn,Button_next,Button_Prev,
          Button_End,Button_change_L,Button_change_R : T_Button;
          Button_Up_Ship,Button_Down_Ship,
          Button_up,Button_down                      : T_Scroll;

          Which_Kit       : word;   { Ktry zestaw }
          Max_Kits        : word;   { Maxymalna ich ilo }

          Which_Alian     : word;   { Ktry sprite wybrany }
          Which_Frm_Shi   : word;   { Tylko taki pic }
          Which_Explode   : word;   { Aktualny wybuch }
          Which_Frm_Exp   : word;   { Tylko taki pic }
          Max_Alians      : word;   { Maxymalna ich ilo }

          Which_Level     : word;   { Ktry level }
          Which_Episode   : word;   { Ktry expisod }
          What_to_Change  : (explodes,frm_exp,ships,frm_shi); { dla button "change" }

          Max_Marked      : word;   { Max. ilo wyznaczonych }
          Screen_Pos      : word;   { Pozycja przysuwajcego }
          P_Ship          : P_ShipsPos;
          GameKit         : p_kit;
          Episode         : t_episodes;



procedure delay(op: longint);
var c,d: word;
begin
d:=op and $FFFF;
c:=op shr 16;
asm
        mov     ah,86h
        mov     dx,d
        mov     cx,c
        int     15h
end;
end;


{$F+}
procedure MyExitProc; far;
begin
Release(HEAP_state);               {  Zwolnienie pamieci  }

if ExitCode<>0 then
   begin
        txt_mode;
        write('FATAL: Very fatal error (no: ',ExitCode,'), ');
        write(errorname(exitcode));
        writeln('PROGRAM HALTED.');
   end;
exitproc:=oldexitproc;
end;
{$F-}


procedure the_end;
begin
Release(HEAP_state);               {  Zwolnienie pamici  }
clear_keyboard;
memW[$0:$417]:=0;                  { Wyzerowanie stanu specjalnych }
Txt_Mode;

ClrScr(15);
GotoXY(0,0);
putchar(32,31,80);
putstring((80 shr 1) - Length('LEVEL MAKER for SPACE SWEEPER') shr 1,0,31,'LEVEL MAKER for SPACE SWEEPER');
GotoXY(0,2);
IF ExitCode=0 Then Writeln('Smooth exit...');
writeln;

writeln('Maximum memo available under 640k  :  ',MemAvail:6,'B');
writeln('Largest contiguous block available :  ',MaxAvail:6,'B');
writeln;
writeln('Max kits in [',ResourceName,']: ',GetMaxKits(ResourceName));
writeln;
halt;
end;


procedure move_data;assembler;
     asm
         cli
         mov    dx,03DAh
@Vert:   in     al,dx               { Czeka na pionowy, 3bit=1 }
         test   al,08h
         je     @Vert

@Wait:   in     al,dx               { Czeka a 0bit=0 (faza ciemna)}
         rcr    al,1
         jc     @Wait

         push ds
         xor  si,si
         mov  ds,[ds:s_virt]
         xor  di,di
         mov  dx,0a000h
         mov  es,dx
         mov  cx,16000       {  64000 / 4  }
         cld
db $66;  rep  movsw          {  REP  MOVSD  (32bit)  }
         pop  ds
         sti
     end;

procedure line(xp,yp,xk,yk: word; col: byte); assembler;
var wsk1    : word;
    wsk2    : word;
    podpr   : word;
asm
        push    si
        push    di
        mov     es,ds:s_virt
        mov     si,320
        mov     cx,xk
        sub     cx,xp
        jz      @VL
        jns     @pdr1
        neg     cx
        mov     bx,xk
        xchg    bx,xp
        mov     xk,bx
        mov     bx,yk
        xchg    bx,yp
        mov     yk,bx
@pdr1:
        mov     bx,yk
        sub     bx,yp
        jz      @HL
        jns     @pdr3
        neg     bx
        neg     si
@pdr3:
        push    si
        mov     podpr,offset @LL1
        cmp     bx,cx
        jle     @pdr4
        mov     podpr,offset @HL1
        xchg    bx,cx
@pdr4:
        shl     bx,1
        mov     wsk1,bx
        sub     bx,cx
        mov     si,bx
        sub     bx,cx
        mov     wsk2,bx
        push    cx
        mov     ax,yp
        mov     bx,xp
        xchg    ah,al
        add     bx,ax
        shr     ax,2
        add     bx,ax

        mov     di,bx
        pop     cx
        inc     cx
        pop     bx
        jmp     podpr
@VL:
        mov     ax,yp
        mov     bx,yk
        mov     cx,bx
        sub     cx,ax
        jge     @pdr31
        neg     cx
        mov     ax,bx
@pdr31:
        inc     cx
        mov     bx,xp
        push    cx

        xchg    ah,al
        add     bx,ax
        shr     ax,2
        add     bx,ax

        pop     cx
        mov     di,bx
        dec     si
        mov     al,col
@pdr32:
        stosb
        add     di,si
        loop    @pdr32
        jmp     @Exit
@HL:
        push    cx
        mov     ax,yp
        mov     bx,xp
        xchg    ah,al
        add     bx,ax
        shr     ax,2
        add     bx,ax

        mov     di,bx
        pop     cx
        inc     cx
        mov     al,col
        rep     stosb
        jmp     @Exit
@LL1:
        mov     al,col
@pdr11:
        stosb
        or      si,si
        jns     @pdr12
        add     si,wsk1
        loop    @pdr11
        jmp     @Exit
@pdr12:
        add     si,wsk2
        add     di,bx
        loop    @pdr11
        jmp     @Exit
@HL1:
        mov     al,col
@pdr21:
        stosb
        add     di,bx
@pdr22:
        or      si,si
        jns     @pdr23
        add     si,wsk1
        dec     di
        loop    @pdr21
        jmp     @Exit
@pdr23:
        add     si,wsk2
        loop    @pdr21
@Exit:
        pop     di
        pop     si
end;




(************************** Nakadanie rysunkw *****************************)
procedure get_background(xp,yp,xk,yk: word; var back: T_BMP_Sprite);
var   tym_ofs   : word;
      xmax,ymax : word;
      s_data,
      o_data    : word;
begin
      xmax:=xk-xp;
      ymax:=yk-yp;
      tym_ofs:=xp+320*(yp+ymax)-320;
      Back.Xmax:=Xmax;
      Back.Ymax:=Ymax;
      Back.Size:=Xmax*Ymax;
      Back.Pal_Exist:=False;
      IF Back.Data=nil Then Back.Data:=Reserve_Mem(Back.Size);
      s_data:=Seg(Back.Data^);
      o_data:=Ofs(Back.Data^);

asm   push  ds
      mov   di,ss:o_data
      mov   si,ss:tym_ofs
      mov   es,ss:s_data
      mov   ds,ds:s_virt
      mov   dx,ss:ymax             { Y-ki maxymalne }
      mov   cx,ss:xmax             { X-y  maxymalne }
      cld
@petla_Y:

      push  cx
      push  si
      rep   movsb                  { Rysowanie lini }
      pop   si
      pop   cx

      sub   si,320                 { Lini do tyu w wirtualnym ekranie }
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;

procedure put_image(xp,yp: word; var  InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax)-320;
      s_data:=seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^);

asm   push  ds
      mov   si,[ss:o_data]
      mov   di,[ss:tym_ofs]
      mov   es,[ds:s_virt]
      mov   ds,[ss:s_data]
      mov   dx,[ss:ymax]          { Y-ki }
      mov   cx,[ss:xmax]          { X-y  }
      cld
@petla_Y:

      push  di
      push  cx
      rep   movsb                 { Linia X-w }
      pop   cx
      pop   di

      sub   di,320                { O 1- lini do tyu }
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;


procedure put_image_and_backup(xp,yp: word; var InPut: T_BMP_Sprite; var BackGr: T_BMP_Sprite);
var   tym_ofs   : word;
      Xmax,Ymax : word;
      s_data,
      o_data    : word;
      s_back,
      o_back    : word;
      s_virt_   : word;
begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax)-320;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^);
      s_back:=Seg(BackGr.Data^);
      o_back:=Ofs(BackGr.Data^);
      s_virt_:=s_virt;
asm   push  ds
      xor   si,si
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   cx,ss:xmax
      cld
@petla_Y:

      push  cx
      mov   ds,ss:s_virt_
      mov   es,ss:s_back
      push  si
      push  di
      xchg  si,di
      add   di,ss:o_back
      rep   movsb
      pop   di
      pop   si
      pop   cx

      push  cx
      mov   es,ss:s_virt_
      mov   ds,ss:s_data
      push  di
      push  si
      add   si,ss:o_data
      rep   movsb
      pop   si
      pop   di
      pop   cx

      add   si,ss:xmax
      sub   di,320
      dec   dx
jne   @petla_Y
      pop   ds
end;
      BackGr.Xmax:=InPut.Xmax;
      BackGr.Ymax:=InPut.Ymax;
      BackGr.Size:=InPut.Size;
end;


procedure put_sprite_and_backup(xp,yp: word; var InPut: T_BMP_Sprite; var BackGr: T_BMP_Sprite);
var   tym_ofs   : word;
      Xmax,Ymax : word;
      s_data,
      o_data    : word;
      s_back,
      o_back    : word;
      s_virt_   : word;
begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax)-320;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^);
      s_back:=Seg(BackGr.Data^);
      o_back:=Ofs(BackGr.Data^);
      s_virt_:=s_virt;
asm   push  ds
      xor   si,si
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   cx,ss:xmax
      cld
@petla_Y:

      push  cx
      mov   ds,ss:s_virt_
      mov   es,ss:s_back
      push  si
      push  di
      xchg  si,di
      add   di,ss:o_back
      rep   movsb
      pop   di
      pop   si
      pop   cx

      push  cx
      mov   es,ss:s_virt_
      mov   ds,ss:s_data
      push  di
      push  si
      add   si,ss:o_data
  @Petla_X:
      mov   al,ds:[si]
      or    al,al
      jz    @Go
      movsb
  loop      @petla_X
      jmp   @koniec
  @Go:
      inc   si
      inc   di
  loop      @petla_X

@koniec:
      pop   si
      pop   di
      pop   cx

      add   si,ss:xmax
      sub   di,320
      dec   dx
jne   @petla_Y
      pop   ds
end;
      BackGr.Xmax:=InPut.Xmax;
      BackGr.Ymax:=InPut.Ymax;
      BackGr.Size:=InPut.Size;
end;




procedure put_sprite(xp,yp: word; var InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax)-320;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^);
asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:

      push  cx
      push  di


  @petla_X:
      mov   al,ds:[si]
      or    al,al
      jz    @go
      movsb
  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
      inc   si
  loop  @petla_X

@koniec:
      pop   di
      pop   cx
      sub   di,320
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;


procedure put_sprite_updown(xp,yp: word; var InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
      tym       : word;
begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*yp;
      tym:=320-xmax;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^);
asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:

      push  cx


  @petla_X:
      mov   al,ds:[si]
      or    al,al
      jz    @go
      movsb
  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
      inc   si
  loop  @petla_X

@koniec:
      pop   cx
      add   di,tym
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;



procedure put_sprite_from_to(xp,yp,From_pos,To_pos: word; var InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      IF ymax-to_pos<=from_pos Then exit;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax-from_pos-to_pos)-320;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^)+to_pos*xmax;
      ymax:=ymax-(from_pos+to_pos);
asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:

      push  cx
      push  di


  @petla_X:
      mov   al,ds:[si]
      or    al,al
      jz    @go
      movsb
  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
      inc   si
  loop  @petla_X

@koniec:
      pop   di
      pop   cx
      sub   di,320
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;




procedure put_image_from_to(xp,yp,From_pos,To_pos: word; var InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      IF ymax-to_pos<=from_pos Then exit;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax-from_pos-to_pos)-320;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^)+to_pos*xmax;
      ymax:=ymax-(from_pos+to_pos);

asm   push  ds
      mov   si,[ss:o_data]
      mov   di,[ss:tym_ofs]
      mov   es,[ds:s_virt]
      mov   ds,[ss:s_data]
      mov   dx,[ss:ymax]          { Y-ki }
      mov   cx,[ss:xmax]          { X-y  }
      cld
@petla_Y:

      push  di
      push  cx
      rep   movsb                 { Linia X-w }
      pop   cx
      pop   di

      sub   di,320                { O 1- lini do tyu }
      dec   dx
jne   @petla_Y
      pop   ds
end;


end;


procedure put_image_from_to_updown(xp,yp,From_pos,To_pos: word; var InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      IF ymax-to_pos<=from_pos Then exit;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp);
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^)+from_pos*xmax;
      ymax:=ymax-(from_pos+to_pos);

asm   push  ds
      mov   si,[ss:o_data]
      mov   di,[ss:tym_ofs]
      mov   es,[ds:s_virt]
      mov   ds,[ss:s_data]
      mov   dx,[ss:ymax]          { Y-ki }
      mov   cx,[ss:xmax]          { X-y  }
      cld
@petla_Y:

      push  cx
      rep   movsb                 { Linia X-w }
      pop   cx

      add   di,320
      sub   di,ss:xmax

      dec   dx
jne   @petla_Y
      pop   ds
end;


end;




procedure put_block(xp,yp,xk,yk: word; col : byte);  { Wypeniony prostokt }
var   tym_ofs   : word;
      xmax,ymax : word;
      tym_sub   : word;
begin
      xmax:=xk-xp;
      ymax:=yk-yp;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+yp*320;
      tym_sub:=320-xmax;
asm   push  ds
      mov   al,[ss:col]
      mov   di,[ss:tym_ofs]
      mov   es,[ds:s_virt]
      mov   dx,[ss:ymax]          { Y-ki }
      mov   cx,[ss:xmax]          { X-y  }
      cld
@petla_Y:

      push  cx
      rep   stosb                 { Linia X-w }
      pop   cx

      add   di,ss:tym_sub

      dec   dx
jne   @petla_Y
      pop   ds
end;
end;


procedure Read_on_screen(xp,yp: word; path: string; SwitchPAL,Show_0: boolean);
Type
    tab = array [1..256] of record
                                  r,g,b,nic : byte;
                            end;
Var i          : word;
    bmp        : file;
    BMPFileHdr : ^BMP_File_Hdr_Type;
    BMPInfoHdr : ^BMP_Info_Hdr_Type;
    BMPSprite  : T_BMP_Sprite;
    Tym        : ^tab;
    Head       : dword;
    Xmax,Ymax  : integer;
    P          : pointer;
begin
FileMode:=0;
assign(bmp,path);
reset(bmp,1);
Check4Error(path);


BMPFileHdr:=Reserve_Mem(SizeOf(BMP_File_Hdr_Type));
BMPInfoHdr:=Reserve_Mem(SizeOf(BMP_Info_Hdr_Type));
BlockRead(bmp,BMPFileHdr^,SizeOf(BMP_File_Hdr_Type));
BlockRead(bmp,BMPInfoHdr^,SizeOf(BMP_Info_Hdr_Type));
Xmax:=BMPinfoHdr^.biWidth;
Ymax:=BMPInfoHdr^.biHeight;
Head:=BMPFileHdr^.bfOffBits;
If xmax mod 4<>0 then xmax:=(trunc(xmax/4))*4+4;
FreeMem(BMPFileHdr,SizeOf(BMP_File_Hdr_Type));
FreeMem(BMPInfoHdr,SizeOf(BMP_Info_Hdr_Type));
BMPSprite.Data:=Reserve_Mem(FileSize(BMP)-head);
Seek(BMP,Head);
BlockRead(BMP,BMPSprite.Data^,FileSize(BMP)-Head);
BMPSprite.Xmax:=Xmax;
BMPSprite.Ymax:=Ymax;
BMPSprite.Size:=FileSize(BMP)-head;
IF Show_0 Then Put_Image(xp,yp,BMPSprite)     { Wywietli z zerem }
          Else Put_Sprite(xp,yp,BMPSprite);   { Naoy bez zera   }

FreeMem(BMPSprite.Data,BMPSprite.Size);

IF SwitchPAL Then                              { Czy ustawi palet }
begin
Tym:=Reserve_Mem(SizeOf(tab));
BMPSprite.Pal:=Reserve_Mem(SizeOf(paleta));
seek(bmp,$36);
BlockRead(bmp,Tym^,sizeof(Tab));               { Get Palette from BMP }
for i:=1 to 256 do
    begin
         BMPSprite.Pal^[i].R:=Tym^[i].B shr 2;
         BMPSprite.Pal^[i].G:=Tym^[i].G shr 2;
         BMPSprite.Pal^[i].B:=Tym^[i].R shr 2;
    end;
FreeMem(Tym,SizeOf(tab));
SetRGBPal(Seg(BMPSprite.pal^),Ofs(BMPSprite.pal^)); { Set RGB-Palette }
FreeMem(BMPSprite.Pal,SizeOf(paleta));
end;


close(bmp);
end;


procedure Check_processor;
function i86check: boolean; assembler;     { Spr. czy to 80x86 }
asm
        pushf
        xor     dx,dx
        push    dx
        popf
        pushf
        pop     ax
        cmp     ax,0f000h
        jz      @ThisIs86
        xor     ax,ax
        jmp     @kon

@ThisIs86:
        mov     ax,1
@kon:
        popf
end;
function i286check: boolean; assembler;
asm
        pushf
        mov     ax,0f000h
        push    ax
        popf
        pushf
        pop     ax
        and     ax,0f000h
        jz      @ThisIs286
        xor     ax,ax
        jmp     @kon2

@ThisIs286:
        mov     ax,1
@kon2:
        popf
end;


begin
write('CPU detected: ');

if i86check then
   begin
        writeln('80086 or 80088 (XT). What the fuck ?!');
        writeln('FATAL: Processor is rather old.');
        writeln('       PROGRAM HALTED.');
        writeln('[!] Change processor to +386 and try again.');
        Halt;
   end;

if i286check then
   begin
        writeln('80286 (AT).');
        writeln('FATAL: Processor is rather old.');
        writeln('       PROGRAM HALTED.');
        writeln('[!] Change processor to +386 and try again.');
        Halt;
   end;

writeln('80386 or higher.');
end;


procedure init_procedures;
const logo   = 'LEVEL MAKER for SPACE SWEEPER';
      please = 'Please send stinger rocket to the SPA.';
begin
clrscr(15);
GotoXY(0,0);
putchar(32,31,80);
putstring(40 - Length(logo) div 2,0,31,logo);
GotoXY(0,2);
putchar(Ord(''),11,80);
GotoXY(40-length(please) div 2,4);
writeln(please);
GotoXY(0,6);
putchar(Ord(''),11,80);
{window(1,10,80,25);}
Writeln('Initial process...');
writeln;
writeln('Maximum memo available under 640k  :  ',MemAvail:6,'B');
writeln('Largest contiguous block available :  ',MaxAvail:6,'B');
writeln;
randomize;

Check_processor;

if NOT BETA_test then
   begin
        EXE_path:=paramstr(0);          { Wydubanie scieki uruchomienia }
        for i:=length(EXE_path) downto 1 do
            if copy(EXE_path,i,1)='\' then break
                                         else delete(EXE_path,i,1);
   end           Else EXE_path:=BETA_Dir;

writeln('Resource directory: ['+EXE_path+'].');
write  ('Init virtual screen... ');
virtual_screen:=Reserve_Mem($FFFF);
s_virt:=Seg(virtual_screen^);       { Seg & Ofs ekranu wirtualnego do zmiennych }
o_virt:=Ofs(virtual_screen^);       { Nie uywane bo si mieci w caym seg     }
FillChar(virtual_screen^, $FFFF, 0);       { Clean-Up }
writeln('at: ',Byte2Hex(Hi(s_virt)),Byte2Hex(Lo(s_virt)),':',
               Byte2Hex(Hi(o_virt)),Byte2Hex(Lo(o_virt)),' - ',
               Byte2Hex(Hi(s_virt)),Byte2Hex(Lo(s_virt)),':',
               Byte2Hex(Hi(o_virt+$FFFF)),Byte2Hex(Lo(o_virt+$FFFF)));

load_ROM_Fonts;
load_font(EXE_path+font1_name);
load_font(EXE_path+font2_name);
Check4CDROM(EXE_path);              { Czy zainstalowany CD i gra jest na nim }

Clear_Keyboard;
Set_MAX_speed;                      { ...of keyboard rate }
OldExitProc:=ExitProc;              { Podczepienie mojego epilogu pod RunTime }
ExitProc:=@MyExitProc;
end;



procedure rectangle(xp,yp,xk,yk: word; col: byte);
begin
     Line(xp,yp,xk,yp,col);
     Line(xp,yp,xp,yk,col);
     Line(xk,yp,xk,yk,col);
     Line(xp,yk,xk,yk,col);
end;


procedure Move_BackGround(bmp_tlo: T_BMP_Sprite);
const kier : boolean = true;
      i    : word    = 1;
begin
     dec(i);
IF (i+200>bmp_tlo.ymax) and (i<bmp_tlo.ymax) Then
   begin
        IF kier Then
           begin
             put_image_from_to(xp,yp,i,0,bmp_tlo);
             put_image_from_to_updown(xp,yp+bmp_tlo.ymax-i,0,bmp_tlo.ymax-(200-(yp+bmp_tlo.ymax-i)),bmp_tlo)
           end
                Else
           begin
             put_image_from_to_updown(xp,yp,i,0,bmp_tlo);
             put_image_from_to(xp,yp+bmp_tlo.ymax-i,0,bmp_tlo.ymax-(200-(yp+bmp_tlo.ymax-i)),bmp_tlo)
           end;
   end
        else
   begin
        IF kier Then
           put_image_from_to(xp,yp,i,bmp_tlo.ymax-(i+200),bmp_tlo)
                Else
           put_image_from_to_updown(xp,yp,i,bmp_tlo.ymax-(i+200),bmp_tlo);
        If i=0 then begin kier:=not kier; i:=bmp_tlo.ymax; end;
   end;
end;



Function Is_in_rectangle(xq,yq,xp,yp,xk,yk: integer): boolean;
begin
     IF (xq>xp) and (xq<xk) and (yq>yp) and (yq<yk) Then Is_in_rectangle:=True
                                                    Else Is_in_rectangle:=false;
end;




(***************** Procedury do przyciskw ******************)
constructor T_Button.Init(xpos,ypos: word; text: string; func: pointer);
begin
     xp:=xpos;
     yp:=ypos;
     xk:=xp+Length(text)*4+3*2;
     yk:=yp+10;
     title:=text;
     @run:=func;
     Button_Out;
end;

procedure T_Button.Button_Out;
begin
     Mouse_Event.Hide;
     Line(xp,yk,xk,yk,darkgray);     { - }
     Line(xk,yp,xk,yk,darkgray);     { | }
     Line(xp,yp,xk,yp,white);        { - }
     Line(xp,yp,xp,yk,white);        { | }
     Put_Block(xp+1,yp+1,xk,yk,lightgray);
     If @Run<>nil Then
     put_string_shadow(xp+(xk-xp) shr 1-(Length(title) shl 2) shr 1,yp+3,4,title,white,black)
                  Else
     put_string_shadow(xp+(xk-xp) shr 1-(Length(title) shl 2) shr 1,yp+3,4,title,LightGray,black);
     Mouse_Event.Show;
     Is_Out:=True;
end;

procedure T_Button.Button_In;
begin
     Mouse_Event.Hide;
     Line(xp,yk,xk,yk,white);
     Line(xk,yp,xk,yk,white);
     Line(xp,yp,xk,yp,darkgray);
     Line(xp,yp,xp,yk,darkgray);
     Put_Block(xp+1,yp+1,xk,yk,lightgray);
     If @Run<>nil Then
     put_string_shadow(xp+1+(xk-xp) shr 1-(Length(title) shl 2) shr 1,yp+3,4,title,white,black)
                  Else
     put_string_shadow(xp+1+(xk-xp) shr 1-(Length(title) shl 2) shr 1,yp+3,4,title,LightGray,black);
     Mouse_Event.Show;
     Is_Out:=False;
end;

procedure T_Button.Button_ReDraw;
begin
     If Is_Out Then Button_Out
               Else Button_In;
end;

function  T_Button.Pressed(xm,ym: word): boolean;
var  st     : word;
     status : (Runing,Miss,Out);
begin
     status:=miss;
   repeat
                   xm:=Mouse_Event.x shr 1;
                   ym:=Mouse_Event.y;

        IF (xm>xp) and (xm<xk) and (ym>yp) and (ym<yk) Then
        begin
             status:=Miss;

             Button_In;
             repeat
                   xm:=Mouse_Event.x shr 1;
                   ym:=Mouse_Event.y;
                   st:=Mouse_Event.ButtonL;
                   If (Is_In_Rectangle(xm,ym,xp,yp,xk,yk)) and (st=0) Then
                      begin status:=Runing; break end;
                   If NOT (Is_In_Rectangle(xm,ym,xp,yp,xk,yk)) and (st=0) Then
                      begin status:=Miss; break end;
                   If NOT (Is_In_Rectangle(xm,ym,xp,yp,xk,yk)) and (st<>0) Then
                      begin status:=out; break end;
             until false;
             Button_out;
        end;
             If status=out then
             begin
                  If st=0 then break;
                  xm:=Mouse_Event.x shr 1;
                  ym:=Mouse_Event.y;
                  st:=Mouse_Event.ButtonL;
             end;
   until status in [miss,runing];

     Pressed:=False;
     If status in [Miss,out] Then exit;
     If @Run<>nil then run;
     Pressed:=True;
end;


function  T_Button.Is_on_button(xm,ym: word): boolean;
begin
     IF Is_In_Rectangle(xm,ym,xp,yp,xk,yk) Then Is_on_Button:=True
                                           Else Is_on_Button:=False;
end;


constructor T_Scroll.Init(xpos,ypos: word; text: string; func: pointer);
begin
     xp:=xpos;
     yp:=ypos;
     xk:=xp+Length(text) shl 2+3*2;
     yk:=yp+10;
     title:=text;
     @run:=func;
     Button_Out;
end;


function  T_Scroll.Pressed(xm,ym: word): boolean;
var  st     : word;
     status : (Runing,Miss,Out);
begin
     status:=Miss;
   repeat
        IF (xm>xp) and (xm<xk) and (ym>yp) and (ym<yk) Then
        begin
             Button_In;
             repeat
                   xm:=Mouse_Event.x shr 1;
                   ym:=Mouse_Event.y;
                   st:=Mouse_Event.ButtonL;
                   If (st=0) Then
                      begin status:=Miss; break end;
                   If Is_In_Rectangle(xm,ym,xp,yp,xk,yk) Then
                      begin status:=Runing; end;
                   If NOT Is_In_Rectangle(xm,ym,xp,yp,xk,yk) Then
                      begin status:=out; break end;
                   If (status=Runing) and (@Run<>nil) then run;
             until false;
             Button_out;
        end;
             If status=out then
             begin
                  If st=0 then break;
                  xm:=Mouse_Event.x shr 1;
                  ym:=Mouse_Event.y;
                  st:=Mouse_Event.ButtonL;
             end;
   until status in [miss,runing];

     If status in [Miss,out] Then Pressed:=False
                             ELse Pressed:=True;
end;


procedure Beep_Err;
begin
{     sound(5000); not using CRT in novadays, need to patch CRT
     delay(10);
     nosound;}
end;

procedure Beep_Ok;
begin
{     sound(150);
     delay(30);
     sound(200);
     delay(30);
     sound(300);
     delay(30);
     sound(400);
     delay(30);
     nosound;  }
end;



procedure msgbox(xp,yp,xk,yk: word; napis: string);
const press  : boolean = false;
var   Button : T_Button;
      tlo    : t_bmp_sprite;

procedure button_ok;
begin
     press:=true;
end;

begin
     press:=false;
     tlo.data:=nil;
     Mouse_Event.Hide;
     Get_BackGround(xp,yp,xk,yk,tlo);
     put_block(xp,yp,xk,yk,lightgray);
     line(xp,yp,xk-1,yp,white);
     line(xp,yp,xp,yk-1,white);
     line(xk-1,yp,xk-1,yk-1,darkgray);
     line(xp,yk-1,xk-1,yk-1,darkgray);
     put_block(xp+2,yp+2,xk-3,yp+8,blue);
     line(xp+2,yp+2,xk-4,yp+2,darkgray);
     line(xp+2,yp+2,xp+2,yp+8,darkgray);
     line(xp+2,yp+8,xk-4,yp+8,white);
     line(xk-4,yp+2,xk-4,yp+8,white);
     put_string_shadow(xp+(xk-xp) shr 1-length(napis)*2,yp+(yk-yp) shr 1-5,4,napis,TxtCol_1st,TxtCol_2nd);
     Button.Init(xp+(xk-xp) shr 1-10,yk-15,' OK ',@button_ok);
     Mouse_Event.Show;
     repeat
           if keypressed then begin readkey; break end;
           if Mouse_Event.PressL<>0 Then
              Button.Pressed(Mouse_Event.X shr 1,Mouse_Event.Y);
     until press;
     Mouse_Event.Hide;
     put_image(xp,yp,tlo);
     Mouse_Event.Show;
     freemem(tlo.data,(xk-xp)*(yk-yp));
end;


function querybox(xp,yp,xk,yk: word; napis,fir,sec: string): boolean;
const press  : boolean = false;
      first  : boolean = false;
var   But_F  : T_Button;
      But_S  : T_Button;
      tlo    : t_bmp_sprite;
      xm,ym  : word;


procedure button_fir;
begin
     press:=true;
     First:=true;
end;

procedure button_sec;
begin
     press:=true;
     First:=false;
end;

begin
     press:=false;
     tlo.data:=nil;
     Mouse_Event.Hide;
     Get_BackGround(xp,yp,xk,yk,tlo);
     put_block(xp,yp,xk,yk,lightgray);
     line(xp,yp,xk-1,yp,white);
     line(xp,yp,xp,yk-1,white);
     line(xk-1,yp,xk-1,yk-1,darkgray);
     line(xp,yk-1,xk-1,yk-1,darkgray);
     put_block(xp+2,yp+2,xk-3,yp+8,blue);
     line(xp+2,yp+2,xk-4,yp+2,darkgray);
     line(xp+2,yp+2,xp+2,yp+8,darkgray);
     line(xp+2,yp+8,xk-4,yp+8,white);
     line(xk-4,yp+2,xk-4,yp+8,white);
     put_string_shadow(xp+(xk-xp) shr 1-length(napis)*2,yp+(yk-yp) shr 1-5,4,napis,yellow,green);
     Mouse_Event.Show;
     But_F.Init(xp+5,yk-15,fir,@button_fir);
     But_S.Init(xp+20+length(fir) shl 2,yk-15,sec,@button_sec);

     repeat
           if keypressed then if chr(readkey)=#27 then begin first:=false; break; end;
           if Mouse_Event.PressL<>0 Then
           begin
              xm:=Mouse_Event.X shr 1;
              ym:=Mouse_Event.Y;
              But_F.Pressed(xm,ym);
              But_S.Pressed(xm,ym);
           end;
     until press;
     Mouse_Event.Hide;
     put_image(xp,yp,tlo);
     Mouse_Event.Show;
     if First Then querybox:=true
              else querybox:=false;
     freemem(tlo.data,(xk-xp)*(yk-yp));
end;


function BoxNewLevel(xp,yp,xk,yk: word): boolean;
const press   : boolean = false;
      Yes     : boolean = false;
      Left_1  : boolean = false;     { =true - Left, =false - Right }
      Left_2  : boolean = false;     { =true - Left, =false - Right }
      Left_3  : boolean = false;     { =true - Left, =false - Right }
      xp_     : word = 0;
      yp_     : word = 0;
      xk_     : word = 0;
      yk_     : word = 0;

var   But_Y   : T_Button;
      But_N   : T_Button;
      But_1_L : T_Scroll;
      But_1_R : T_Scroll;
      But_2_L : T_Scroll;
      But_2_R : T_Scroll;
      But_3_L : T_Scroll;
      But_3_R : T_Scroll;
      tlo     : t_bmp_sprite;
      xm,ym   : word;


procedure button_Y;
begin
     press:=true;
     Yes:=true;
end;

procedure button_N;
begin
     press:=true;
     Yes:=false;
end;

procedure button_L_1;
var  s: string[2];
begin
     if which_kit>1 then dec(which_kit);
     str(which_kit,s);
     put_string_shadow(xp_+80,yp_+20,4,'88',green,green);
     put_string_shadow(xp_+80,yp_+20,4,s,yellow,green);
     delay(300);
end;

procedure button_R_1;
var  s: string[2];
begin
     if which_kit+1<GetMaxKits(ResourceName) then inc(which_kit);
     str(which_kit,s);
     put_string_shadow(xp_+80,yp_+20,4,'88',green,green);
     put_string_shadow(xp_+80,yp_+20,4,s,yellow,green);
     delay(300);
end;


begin
     xp_:=xp;
     yp_:=yp;
     xk_:=xk;
     yk_:=yk;
     press:=false;
     tlo.data:=nil;
     Mouse_Event.Hide;
     Get_BackGround(xp,yp,xk,yk,tlo);
     put_block(xp,yp,xk,yk,lightgray);
     line(xp,yp,xk-1,yp,white);
     line(xp,yp,xp,yk-1,white);
     line(xk-1,yp,xk-1,yk-1,darkgray);
     line(xp,yk-1,xk-1,yk-1,darkgray);
     put_block(xp+2,yp+2,xk-3,yp+8,blue);
     line(xp+2,yp+2,xk-4,yp+2,darkgray);
     line(xp+2,yp+2,xp+2,yp+8,darkgray);
     line(xp+2,yp+8,xk-4,yp+8,white);
     line(xk-4,yp+2,xk-4,yp+8,white);
{     put_string_shadow(xp+(xk-xp) shr 1-length(napis)*2,yp+(yk-yp) shr 1-5,4,napis,yellow,green);}
     Mouse_Event.Show;
     But_Y.Init(xp+5,yk-15,' YES ',@button_y);
     But_N.Init(xp+20+length(' YES ') shl 2,yk-15,' CANCEL ',@button_n);

     put_string_shadow(xp+5,yp+20,4,'Which image kit ?',yellow,green);
     But_1_L.Init(xp+113,yp+17,'<-',@button_L_1);
     But_1_R.Init(xp+130,yp+17,'->',@button_R_1);


     repeat
           if keypressed then if chr(readkey)=#27 then begin yes:=false; break; end;
           if Mouse_Event.PressL<>0 Then
           begin
              xm:=Mouse_Event.X shr 1;
              ym:=Mouse_Event.Y;
              But_Y.Pressed(xm,ym);
              But_N.Pressed(xm,ym);
              But_1_L.Pressed(xm,ym);
              But_1_R.Pressed(xm,ym);
           end;
     until press;
     Mouse_Event.Hide;
     put_image(xp,yp,tlo);
     Mouse_Event.Show;
     if YES   Then BoxNewLevel:=true
              else BoxNewLevel:=false;
     freemem(tlo.data,(xk-xp)*(yk-yp));
end;



(******  Zaadowanie do tablic pointw do image'w  *******)
procedure Load_images;

begin
     if gamekit=nil then new(gamekit);
     ReadKit(ResourceName,Which_Kit,GameKit);

     Put_Image(0,0,GameKit^.Cockpit^.Image^.Img);
     SetColors(GameKit);

     DelBranche(GameKit^.Cockpit);
     DelBranche(GameKit^.Colors);

     Max_Alians:=GetMaxSprite(Gamekit^.Alians);

     Episode.levels:=nil;
end;



procedure Kill_images; (******  Zaadowanie do tablic pointw do image'w  *******)
begin
     DisposeKit(GameKit);
end;


procedure write_values;
begin
     str(memavail,stng);
     put_string_shadow(xp+1,yp+1,4,stng+' B free',TxtCol_1st,TxtCol_2nd);

     str(which_episode,stng);
     put_string_shadow(xp+70,yp+1,4,'Episode: '+stng,TxtCol_1st,TxtCol_2nd);

     str(which_level,stng);
     put_string_shadow(xp+130,yp+1,4,'Level: '+stng,TxtCol_1st,TxtCol_2nd);

     str(which_kit,stng);
     put_string_shadow(xp+180,yp+1,4,'Kit: '+stng,TxtCol_1st,TxtCol_2nd);


     str(Screen_Pos,stng);
     put_string_shadow(35,157,4,'00000',0,TxtCol_2nd);
     put_string_shadow(35+length('00000')*4-length(stng)*4,157,4,stng,TxtCol_1st,TxtCol_2nd);

     str(Max_Marked,stng);
     put_string_shadow(38,165,4,'0000',0,TxtCol_2nd);
     put_string_shadow(38+length('0000')*4-length(stng)*4,165,4,stng,TxtCol_1st,TxtCol_2nd);
end;


(**********************************)
procedure Put_New_Ship;
begin
        IF xm+GetFrame(GameKit^.Alians,which_alian,1)^.xmax>=xk Then exit;
        IF ym+GetFrame(GameKit^.Alians,which_alian,1)^.ymax>=yk Then exit;
        inc(Max_Marked);

        P_Ship:=LastShipPos(@Episode,which_episode,which_level);

        P_Ship^.What:=flying;
        P_Ship^.x:=xm-xp;
        P_Ship^.y:=Screen_Pos+(yk-ym);
        P_Ship^.Fly_Case.which:=which_alian;
        P_Ship^.Crash_Case.which:=which_explode;
        P_Ship^.Crash_Case.how:=stars_image;
        P_Ship^.FireAble:=No;
        P_Ship^.Bonus:=0;
        P_Ship^.Frame:=1;
        P_Ship^.Delay:=0;
        P_Ship^.Next:=nil;

        Mouse_Event.Hide;
        put_sprite(xm,ym,GetFrame(GameKit^.Alians,which_alian,1)^);

        Mouse_Event.Show;
        Beep_Ok;
end;



(************* Proc obsugi programu **************)
Procedure Rysuj_Statek(i: word);      { i - ktry statek }
var  xt,yt,wys : integer;
     P_Shi     : P_ShipsPos;
begin
     P_Shi:=GetShipPos(@Episode,which_episode,which_level,i);
     wys:=GetFrame(GameKit^.Alians,P_Shi^.Fly_Case.which,1)^.ymax;
     xt:=abs(xp+P_Shi^.x);
     yt:=integer(Screen_Pos+yk-P_Shi^.y);
   IF (yt<yk-yp) and
      (integer(yt)+wys>yp) Then
   begin
     If (integer(yt+wys)<yk-yp) and (integer(yt)>0)
        then put_sprite(xt,yt,GetFrame(GameKit^.Alians,P_Shi^.Fly_Case.which,1)^)
             else
     If (integer(yt+wys)>=yk-yp)
        then put_sprite_from_to(xt,yt,0,yt+wys-(yk-yp),GetFrame(GameKit^.Alians,P_Shi^.Fly_Case.which,1)^)
             else
     If (yt+wys>yp)
        then put_sprite_from_to(xt,0,Abs(yt),0,GetFrame(GameKit^.Alians,P_Shi^.Fly_Case.which,1)^);
   end;
end;



procedure Put_In_Window(P: P_BMP_Sprite);
begin
     Mouse_Event.Hide;
     Put_Block(8,80,72,152,black);
     put_sprite(9,80,P^);
     case what_to_change of
       explodes : put_string_shadow(40,142,4,'exp imgs',TxtCol_1st,TxtCol_2nd);
       frm_exp  : put_string_shadow(40,142,4,'exp frms',TxtCol_1st,TxtCol_2nd);
       ships    : put_string_shadow(40,142,4,'images',TxtCol_1st,TxtCol_2nd);
       frm_shi  : put_string_shadow(40,142,4,'frames',TxtCol_1st,TxtCol_2nd);
     end;
     Button_down_ship.button_redraw;
     Mouse_Event.Show;
end;

procedure proc_up_ship;
begin
     case what_to_change of
     explodes :
            begin IF Which_Explode>1 Then dec(which_explode)
                                     else Beep_Err;
                  Put_In_Window(GetFrame(GameKit^.Explodes,which_explode,which_frm_exp));
            end;
     frm_exp  :
            begin IF Which_Frm_Exp>1 Then dec(which_frm_exp)
                     else Beep_Err;
                   Put_In_Window(GetFrame(GameKit^.Explodes,which_explode,which_frm_exp));
            end;
     ships    :
            begin IF Which_Alian>1 Then dec(which_alian)
                                   else Beep_Err;
                   Put_In_Window(GetFrame(GameKit^.Alians,which_alian,which_frm_shi));
                   which_frm_shi:=1;
                   which_frm_exp:=1;
            end;
     frm_shi  :
            begin IF Which_Frm_Shi>1 Then dec(which_frm_shi)
                                     else Beep_Err;
                   Put_In_Window(GetFrame(GameKit^.Alians,which_alian,which_frm_shi));
            end;
     end;
     delay(200);
end;

procedure proc_down_ship;
begin
     case what_to_change of
     explodes :
            begin IF Which_Explode<GetMaxSprite(GameKit^.Explodes)
                  Then inc(which_explode)
                  else Beep_Err;
                  Put_In_Window(GetFrame(GameKit^.Explodes,which_explode,which_frm_exp));
            end;
     frm_exp  :
            begin IF Which_Frm_Exp<GetMaxFrame(GameKit^.Explodes,which_explode)
                  Then inc(which_frm_exp)
                  else Beep_Err;
                  Put_In_Window(GetFrame(GameKit^.Explodes,which_explode,which_frm_exp));
            end;
     ships    :
            begin IF Which_Alian<GetMaxSprite(GameKit^.Alians)
                  Then inc(which_alian)
                  else Beep_Err;
                  Put_In_Window(GetFrame(GameKit^.Alians,which_alian,which_frm_shi));
                  which_frm_shi:=1;
                  which_frm_exp:=1;
            end;
     frm_shi  :
            begin IF Which_Frm_Shi<GetMaxFrame(GameKit^.Alians,which_Alian)
                  Then inc(which_frm_shi)
                  else Beep_Err;
                  Put_In_Window(GetFrame(GameKit^.Alians,which_alian,which_frm_shi));
            end;
     end;
     delay(200);
end;


procedure proc_quit;
begin
     if NOT QueryBox(90,80,240,125,'Do you want to quit ?',' Yes ',' No  ') then exit;
     Kill_images;
     The_End;
end;


procedure proc_up;
begin
   delay(5);
   IF mem[$0:$0417] and 3=0 Then inc(Screen_Pos)      { Shift'y }
                            Else inc(Screen_Pos,5);
   Mouse_Event.Hide;
   Put_Block(xp,yp,xk,yk,0);

   For i:=1 to Max_Marked do Rysuj_Statek(i);

   xm:=Mouse_Event.X shr 1;
   ym:=Mouse_Event.Y;

   Mouse_Event.Show;
end;


procedure proc_down;
begin
   delay(5);
   IF mem[$0:$0417] and 3=0 Then          { Shift'y wyczone }
   begin
   If Screen_Pos>1 Then Dec(Screen_Pos)
                   Else begin Screen_Pos:=1; Beep_Err; end;
   end else
   begin
   If Screen_Pos>6 Then Dec(Screen_Pos,5)
                   Else begin Screen_Pos:=1; Beep_Err; end;
   end;

   Mouse_Event.Hide;
   Put_Block(xp,yp,xk,yk,0);

   For i:=1 to Max_Marked do Rysuj_Statek(i);

   xm:=Mouse_Event.X shr 1;
   ym:=Mouse_Event.Y;

   Mouse_Event.Show;
end;


procedure proc_pgup;
begin
   inc(Screen_Pos,200);

   Mouse_Event.Hide;
   Put_Block(xp,yp,xk,yk,0);

   For i:=1 to Max_Marked do Rysuj_Statek(i);

   xm:=Mouse_Event.X shr 1;
   ym:=Mouse_Event.Y;

   Mouse_Event.Show;
end;

procedure proc_pgdn;
begin
   If integer(Screen_Pos-200)>0 Then Dec(Screen_Pos,200)
                                else begin Screen_Pos:=1; Beep_Err; end;
   Mouse_Event.Hide;
   Put_Block(xp,yp,xk,yk,0);

   For i:=1 to Max_Marked do Rysuj_Statek(i);


   xm:=Mouse_Event.X shr 1;
   ym:=Mouse_Event.Y;

   Mouse_Event.Show;
end;

procedure proc_undo;
var  P_Shi : P_ShipsPos;
     i     : word;
begin
     If Max_Marked>0 Then Dec(Max_Marked)
                     else begin Beep_Err; exit end;
     Mouse_Event.Hide;
     DisposeShipPos(@Episode,which_episode,which_level,Max_Marked+1);

     Put_Block(xp,yp,xk,yk,0);

     For i:=1 to Max_Marked do Rysuj_Statek(i);

     Mouse_Event.Show;
end;

procedure proc_clean;
begin
     if NOT QueryBox(90,80,240,125,'Clear all ships-positions ?',' Yap ',' No  ') then exit;
     If Max_Marked=0 Then begin Beep_Err; exit end;
     Mouse_Event.Hide;

     put_string_shadow(90,100,1,'Deleting positions...',TxtCol_1st,TxtCol_2nd);
     For i:=Max_Marked downto 1 do
     begin
         DisposeShipPos(@Episode,which_episode,which_level,i);
         Dec(Max_Marked);
         write_values;
     end;
     Put_Block(xp,yp,xk,yk,0);

     Mouse_Event.Show;
     Beep_Ok;
end;



procedure proc_change_R;
begin
     if what_to_change<>frm_shi then what_to_change:=Succ(what_to_change)
                                else what_to_change:=explodes;
     case what_to_change of
     explodes,frm_exp : Put_In_Window(GetFrame(GameKit^.Explodes,which_explode,which_frm_exp));
     ships,frm_shi    : Put_In_Window(GetFrame(GameKit^.Alians,which_alian,which_frm_shi));
     end;
end;

procedure proc_change_L;
begin
     if what_to_change<>explodes then what_to_change:=Pred(what_to_change)
                                 else what_to_change:=frm_shi;
     case what_to_change of
     explodes,frm_exp : Put_In_Window(GetFrame(GameKit^.Explodes,which_explode,which_frm_exp));
     ships,frm_shi    : Put_In_Window(GetFrame(GameKit^.Alians,which_alian,which_frm_shi));
     end;
end;

procedure proc_next;
var  epi,lev : word;
begin
     GetLevelPoint(@Episode,which_episode,which_level)^.maxships:=max_marked;
     GetLevelPoint(@Episode,which_episode,which_level)^.whichkit:=which_kit;
     GetLevelPoint(@Episode,which_episode,which_level)^.maxpos:=screen_pos-(yk-yp);

     epi:=which_episode;
     lev:=which_level;
     if QueryBox(90,80,240,125,'Next what ?','Episode','Level') then
        begin inc(epi);
              lev:=1;
        end   else inc(lev);


{     if NOT QueryBox(90,80,240,125,'Are you sure ?',' Yes ',' No  ') then exit;}

     which_episode:=epi;
     which_level:=lev;
     Which_Alian:=1;
     which_frm_shi:=1;
     which_frm_exp:=1;

     if GetEpisodePoint(@Episode,which_episode)=nil then
     begin
          Reserve4Episode(@Episode,which_episode);
          fillchar(GetEpisodePoint(@Episode,which_episode)^,sizeof(t_episodes),0);
     end;

     if GetLevelPoint(@Episode,which_episode,which_level)=nil then
     begin
        if NOT BoxNewLevel(90,50,240,140) then exit;
{        if NOT QueryBox(90,80,240,125,'Are you sure ?',' Yes ',' No  ') then exit;}
        Reserve4level(@Episode,which_episode,which_level);
        fillchar(GetLevelPoint(@Episode,which_episode,which_level)^,sizeof(T_Levels),0);
        GetLevelPoint(@Episode,which_episode,which_level)^.maxships:=0;
        GetLevelPoint(@Episode,which_episode,which_level)^.whichkit:=which_kit;
        GetLevelPoint(@Episode,which_episode,which_level)^.maxpos:=0;
        Max_Marked:=0;
     end
                     else
     begin
        Max_Marked:=GetLevelPoint(@Episode,which_episode,which_level)^.MaxShips;
        which_kit:=GetLevelPoint(@Episode,which_episode,which_level)^.whichkit;
     end;


     DisposeKit(GameKit);      { Zwalnia pami KITa }
     ReadKit(ResourceName,which_kit,GameKit);

     Screen_Pos:=0;
     proc_pgdn;       { Odmalowanie statkw }
     proc_up_ship;    { Odmalowanie aktualnego statku }
     st:=0;
end;


procedure proc_prev;
var  epi,lev : word;
begin
     GetLevelPoint(@Episode,which_episode,which_level)^.maxships:=max_marked;
     GetLevelPoint(@Episode,which_episode,which_level)^.whichkit:=which_kit;
     GetLevelPoint(@Episode,which_episode,which_level)^.maxpos:=screen_pos-(yk-yp);

     epi:=which_episode;
     lev:=which_level;
     if QueryBox(90,80,240,125,'Previous what ?','Episode','Level') then
        begin
             if epi>1 then dec(epi);
             lev:=1;
        end
        else
             if lev>1 then dec(lev);

     which_episode:=epi;
     which_level:=lev;
     Which_Alian:=1;
     which_frm_shi:=1;
     which_frm_exp:=1;


     if GetEpisodePoint(@Episode,which_episode)=nil then
     begin
          Reserve4Episode(@Episode,which_episode);
          fillchar(GetEpisodePoint(@Episode,which_episode)^,sizeof(t_episodes),0);
     end;

     if GetLevelPoint(@Episode,which_episode,which_level)=nil then
     begin
        if NOT QueryBox(90,80,240,125,'Are you sure ?',' Yes ',' No  ') then exit;
        Reserve4level(@Episode,which_episode,which_level);
        GetLevelPoint(@Episode,which_episode,which_level)^.maxships:=0;
        GetLevelPoint(@Episode,which_episode,which_level)^.whichkit:=which_kit;
        GetLevelPoint(@Episode,which_episode,which_level)^.maxpos:=0;
        Max_Marked:=0;
     end
                     else
     begin
        Max_Marked:=GetLevelPoint(@Episode,which_episode,which_level)^.MaxShips;
        which_kit:=GetLevelPoint(@Episode,which_episode,which_level)^.whichkit;
     end;

     DisposeKit(GameKit);      { Zwalnia pami KITa }
     ReadKit(ResourceName,which_kit,GameKit);

     Screen_Pos:=0;
     proc_pgdn;       { Odmalowanie statkw }
     proc_up_ship;    { Odmalowanie aktualnego statku }
     st:=0;

end;

procedure proc_save;
var  head  : T_Resource;
     f     : file;
begin
     GetLevelPoint(@Episode,which_episode,which_level)^.maxships:=max_marked;
     GetLevelPoint(@Episode,which_episode,which_level)^.whichkit:=which_kit;
     GetLevelPoint(@Episode,which_episode,which_level)^.maxpos:=screen_pos-(yk-yp);
{     Max_Marked:=0;}

     filemode:=2;
     assign(f,Resourcename);
     reset(f,1);
     Check4Error(Resourcename);
     blockread(f,head,sizeof(head));
     Check4Error(GetFName(f));

     if head.episodes<>nil then
        begin
             seek(f,longint(head.episodes));
             Truncate(f);
             head.episodes:=nil;
             seek(f,0);
             blockwrite(f,head,sizeof(head));
             check4Error(GetFName(f));
        end;
     close(f);

     WriteEpisodes(ResourceName,@Episode);
end;


procedure proc_load;
var i, levi, epi : word;
    epi_max      : word;
    p_epi        : p_episodes;
    p_lev        : p_levels;
begin
    DisposeKit(GameKit);      { Zwalnia pami KITa }
    ReadKit(ResourceName,which_kit,GameKit);
    Episode:=T_Episodes(ReadEpisode(ResourceName,1)^);
    Episode.Levels:=ReadLevel(ResourceName, 1, 1);
    epi_max:=GetMaxEpisodes(ResourceName);
    p_epi:=@Episode;
    p_lev:=Episode.Levels;
    epi:=1;   {  txt_mode;}
    repeat
    levi:=1;
    {repeat} while p_lev^.next <> nil do
    begin
         inc(levi);          write('levi ',levi);
         p_lev^.next:=P_Levels(ReadLevel(ResourceName, epi, levi));
         p_lev:=p_lev^.next;
         if i=GetMaxLevels(Resourcename,epi) then break;

    end;
{    until false;}
    inc(epi);
    if epi=epi_max+1 then break;

                          writeln('epi ',epi,' ',epi_max);
    p_epi^.next:=P_Episodes(ReadEpisode(ResourceName,epi));
    p_epi:=p_epi^.next;    {writeln('->');}
    p_epi^.levels:=P_Levels(ReadLevel(ResourceName, epi, 1)); {writeln('<-');}
    p_lev:=p_epi^.levels;
    until false;
{                    writeln('halti');
                   halt;}
    which_kit:=Episode.Levels^.whichkit;
    max_marked:=Episode.Levels^.MaxShips;
    screen_pos:=Episode.Levels^.maxpos-(yk-yp);
    which_episode:=1;
    which_level:=1;
    Which_Alian:=1;
    which_frm_shi:=1;
    which_frm_exp:=1;
    Mouse_Event.Hide;
    Put_Block(xp,yp,xk,yk,0);
    For i:=1 to Max_Marked do Rysuj_Statek(i);
    Mouse_Event.Show;
end;

(***************)
procedure Mouse_n_Buttons_Init;
begin
Mouse_Event.Init;
Mouse_Event.install;
Button_Up_Ship.init(07,068,  '  UP  ',@proc_up_ship);
Button_Change_L.init(40,068, #17+#17,@proc_change_L);
Button_Change_R.init(57,068, #16+#16,@proc_change_R);
Button_Down_Ship.Init(07,141,' DOWN ',@proc_down_ship);

Button_pgup.init(02,yp   ,' PGUP  ',@proc_pgup);
Button_up.  init(39,yp   ,' UP    ',@proc_up);
Button_save.init(02,yp+12,' SAVE  ',@proc_save);
Button_load.init(02,yp+24,' LOAD  ',@proc_load);
Button_new. init(02,yp+36,' NEW   ',nil);
Button_quit.init(02,yp+48,' EXIT  ',@proc_quit);

Button_Undo.init(02,177,  ' UNDO  ',@proc_undo);
Button_Cls .init(39,177,  ' CLS   ',@proc_clean);
Button_pgdn.init(02,yk-11,' PGDN  ',@proc_pgdn);
Button_down.init(39,yk-11,' DOWN  ',@proc_down);

Button_next.init(39,yp+12,' NEXT  ',@proc_next);
Button_prev.init(39,yp+24,' PREV  ',@proc_prev);
Button_end.init(39,yp+36,' END   ',nil);
end;

procedure Check4Event;
begin
Button_Up_Ship.Pressed(xm,ym);
Button_Change_L.Pressed(xm,ym);
Button_Change_R.Pressed(xm,ym);
Button_Down_Ship.Pressed(xm,ym);

Button_up.Pressed(xm,ym);
Button_pgup.Pressed(xm,ym);
Button_save.Pressed(xm,ym);
Button_load.Pressed(xm,ym);
Button_new.Pressed(xm,ym);
Button_quit.Pressed(xm,ym);
Button_down.Pressed(xm,ym);
Button_pgdn.Pressed(xm,ym);

Button_Undo.Pressed(xm,ym);
Button_Cls.Pressed(xm,ym);
Button_prev.Pressed(xm,ym);
Button_next.Pressed(xm,ym);
Button_end.Pressed(xm,ym);
end;





(******************************  M * A * I * N  *****************************)

begin
Mark(HEAP_state);
init_procedures;
initgraph256;                       { Init 320x200x256 }
s_virt:=$a000;
put_string_shadow(50,95,1,'Please wait, while loading...',15,2);
s_virt:=seg(virtual_screen^);


which_kit:=1;
which_level:=1;
which_episode:=1;

Which_Alian:=1;
which_frm_shi:=1;
which_frm_exp:=1;
which_explode:=1;
Max_Marked:=0;
Screen_Pos:=0;
what_to_change:=ships;

load_images;        { Zaadowanie tablic rysunkami }

move_data;
s_virt:=$a000;
Mouse_n_Buttons_init;
Put_Block(20,90,71,130,black);
put_string_shadow(6,157,4,'POS:   00000',TxtCol_1st,TxtCol_2nd);
put_string_shadow(6,165,4,'ALIANS: 0000',TxtCol_1st,TxtCol_2nd);
Put_In_Window(GetFrame(GameKit^.Alians,which_alian,which_frm_shi));
write_values;
Mouse_Event.Show;

Reserve4level(@Episode,1,1);
fillchar(GetLevelPoint(@Episode,1,1)^,sizeof(t_levels),0);

(***************************)
Mouse_Event.SetXY(10,10);
tlo.data:=nil;

repeat

freemem(tlo.data,oldsize);
tlo.xmax:=GetFrame(GameKit^.Alians,which_alian,1)^.xmax;         { Cae to }
tlo.ymax:=GetFrame(GameKit^.Alians,which_alian,1)^.ymax;
tlo.data:=Reserve_Mem(tlo.xmax*tlo.ymax);
oldsize:=tlo.xmax*tlo.ymax;
xm:=Mouse_Event.X shr 1;
ym:=Mouse_Event.Y;
If Is_In_Rectangle(xm,ym,xp,yp,xk,yk) Then
begin
Mouse_Event.Hide;
Get_BackGround(xm,ym,xm+GetFrame(GameKit^.Alians,which_alian,1)^.xmax,
                     ym+GetFrame(GameKit^.Alians,which_alian,1)^.ymax,tlo);
Mouse_Event.Show;
xo:=xm;
yo:=ym;
end else xo:=1;

repeat
      st:=Mouse_Event.PressL;
      xm:=Mouse_Event.X shr 1;
      ym:=Mouse_Event.Y;
      if st<>0 then break;
      IF Is_In_Rectangle(xm,ym,xp,yp,xk,yk) Then
         begin
              IF xm+GetFrame(GameKit^.Alians,which_alian,1)^.xmax>=xk Then continue;
              IF ym+GetFrame(GameKit^.Alians,which_alian,1)^.ymax>=yk Then continue;
              Mouse_Event.Hide;
              If Is_In_Rectangle(xo,yo,xp,yp,xk,yk) Then put_image(xo,yo,tlo);

              Get_BackGround(xm,ym,xm+GetFrame(GameKit^.Alians,which_alian,1)^.xmax,
                     ym+GetFrame(GameKit^.Alians,which_alian,1)^.ymax,tlo);

              put_sprite(xm,ym,GetFrame(GameKit^.Alians,which_alian,1)^);
              rectangle(xm,ym,xm+GetFrame(GameKit^.Alians,which_alian,1)^.xmax-1,
                        ym+GetFrame(GameKit^.Alians,which_alian,1)^.ymax-1,lightgreen);

              xo:=xm;
              yo:=ym;
              repeat
                    xm:=Mouse_Event.X shr 1;
                    ym:=Mouse_Event.Y;
                    st:=Mouse_Event.PressL;
              until (((xm<>xo) and (ym<>yo)) or ((xm<>xo) or (ym<>yo))) or (keypressed) or (st<>0);
              Mouse_Event.Show;
         end;

      IF keypressed Then begin ch:=readkey;
                               If chr(ch)=#27 Then the_end;
                         end;
until (st<>0);

IF Is_In_Rectangle(xo,yo,xp,yp,xk,yk) Then  { eby mysza nie mrugaa, gdy }
begin                                       { si nacinie na pustym polu }
     Mouse_Event.Hide;
     put_image(xo,yo,tlo);
     Mouse_Event.Show;
end;

Check4Event;

IF Is_In_Rectangle(xm,ym,xp,yp,xk,yk) and (st<>0) Then Put_New_Ship;

write_values;
until chr(ch)=#27;

Mouse_Event.remove;
Mouse_Event.Hide;
The_End;
end.