(*
        SpaceSweeper misc helpers

        Author: Piotr Skowronek, pskowronek@adfinem.net
        Written in: 1997
        Licence: LGPL
 *)

Unit MISC;         { Dostosowany do GRY - Space Sweeper }
{$I-,R-,G+,S-,D+,Q-,V-,B-}
interface          { Misc functions }
uses DOS,TYPES;


(**** Pomocnicze ****)
function  StrCmp(fir,sec: pchar): boolean;     { Porwnywanie string'w }
Function  Reserve_Mem(size: word): pointer;    { Alokacja miejsca w pamici }
procedure FreeM(p: pointer; size: word);

procedure Check4Error(name: string);           { Sprawdza na obecno bdw }
function  ErrorName(err: integer): PChar;
procedure WriteExitMsg(name: string);
function  Byte2Hex(b: byte): st2;
function  GetFName(var F: file): string;
procedure Check4CDROM(sciezka_EXE: string);

procedure initgraph256;
procedure clrscr(atr: byte);                    { IN:  Atrybut }
procedure putchar(znak,atr: byte; ile: word);
procedure GotoXY(x,y: byte);
procedure putstring(x,y,atr: byte; napis: string);
procedure clear_keyboard;
procedure Set_max_speed;
function sqrt_int(w: word): word;
procedure setrgbpal(s,o:word);                  { Set RGB palete colorow }
procedure getrgbpal(s,o:word);
procedure fade_down;
procedure fade_up(s,o: word);
function  Is_txtmode: boolean;
procedure txt_mode;

(********************** Nakadanie textu ************************)
procedure put_char_XY(xp,yp: word; No,ch,col: byte; InPut: T_Font);
procedure put_string_XY(xp,yp: word; No : byte; napis: string; col: byte);
procedure put_string_shadow(xp,yp: word; No : byte; napis: string; col1,col2: byte);
procedure load_ROM_fonts;
procedure Load_Font(font_name: string);
procedure WriteMSG(txt: string);
implementation



(****** Pomocnicze ******)
procedure txt_mode; assembler;
asm
        mov     ah,0fh
        int     10h
        cmp     al,03h
        jz      @Juz_w_textowym

        mov     ax,0003h
        int     10h

@Juz_w_textowym:
end;

function Is_txtmode: boolean; assembler;
asm
        mov     ah,0fh
        int     10h
        cmp     al,03h
        jz      @Juz_w_textowym
        xor     al,al
@Juz_w_textowym:
        mov     al,1
@koniec:
end;

function ErrorName(err: integer): PChar;
begin
     case err of
        0 : ErrorName:='';
        2 : ErrorName:='File not found.';
        3 : ErrorName:='Path not found.';
        4 : ErrorName:='Too many open files.';
        5 : ErrorName:='File access denied.';
      100 : ErrorName:='Disk read error.';
      101 : ErrorName:='Disk write error.';
      106 : ErrorName:='Invalid numeric format.';
      150 : ErrorName:='Disk is write protected.';
      152 : ErrorName:='Disk not ready.';
      162 : ErrorName:='Hardware error.';
      200 : ErrorName:='Division by zero.';
      201 : ErrorName:='Range check error.';
      202 : ErrorName:='Stack overflow error.';
      203 : ErrorName:='Heap overflow (not enough memo?).';
      204 : ErrorName:='Invalid pointer operation.';
      255 : ErrorName:='[!] Ctrl-Break pressed [!] (What for?)';
       Else ErrorName:='Unanticipated error. Report kindly requested.';
     end;

end;

procedure Check4Error(name: string);
var  Blad : Integer;
begin
     Blad:=IOResult;
     IF Blad=0 Then Exit;
     txt_mode;
     Writeln('FATAL: Was an error while accessing resource file.');
     Write  ('       Name of file is: <',name,'>');
     if blad in [2,3] then            { File/path not found }
     Writeln(', check for his existing.  ');
     Writeln('       ERR[',blad,']: ',ErrorName(blad));
     Writeln('PROGRAM HALTED');
     Halt;
end;

procedure WriteExitMsg(name: string);
begin
     txt_mode;
     writeln('Error:  ',name);
     writeln('PROGRAM HALTED');
     halt;
end;

function Byte2Hex(b: byte): st2;
const
 hexChars: array [0..$F] of Char = '0123456789ABCDEF';
begin
     Byte2Hex:=hexChars[b shr 4]+hexChars[b and $F];
end;


Function reserve_mem(size: word): pointer;      { Alokacja miejsca w pamici }
var  P: Pointer;
begin
     IF MaxAvail<Size Then
        begin
             txt_mode;
             writeln('FATAL: Not enough memo to continue program.');
             writeln('       Free about over ',Size-MaxAvail,' bytes and try again.');
             writeln('PROGRAM HALTED');
             halt;
        end;
     GetMem(P,size);
     Reserve_Mem:=P;
end;

procedure FreeM(p: pointer; size: word);
begin
     if p<>nil Then FreeMem(p,size);
end;


function GetFName(var F: file): string;
var  i: byte;
     s: string[90];
begin
     s:='';
     for i:=1 to 255 do
         if mem[seg(f):ofs(f)+47+i]=0 then begin s[0]:=chr(i-1); break; end
         else
         s[i]:=chr(mem[seg(f):ofs(f)+47+i]);
     GetFName:=s;
end;

function StrCmp(fir,sec: pchar): boolean;
var  i: word;
begin
     For i:=0 to $FFFF do
         begin
              if (fir[i]=#0) and (sec[i]=#0) Then begin StrCmp:=True; exit end;
              if (fir[i]<>sec[i]) Then begin StrCmp:=False; exit end;
         end;
end;


procedure Check4CDROM(sciezka_EXE: string);
var  drv : byte;
     label installed,unknown,not_installed,cdromed,not_cdromed,
           nonremoveable,removeable;
begin
     write('Looking for CD-ROM driver: ');
     asm                         { Sprawdza czy MSCDEX jest zainstalowany }
        mov   ax,1100h
        push  0DADAh
        int   2fh
        pop   bx
        or    al,al
        jz    not_installed
        cmp   al,01h
        jz    not_installed
        cmp   al,0ffh
        jnz   unknown
        cmp   bx,0DADAh
        jz    not_installed
        jmp   installed
     end;
     unknown:
     writeln('unknown response.');
     exit;

     not_installed:
     writeln('not installed.');
     exit;

     installed:
     writeln('installed.');

     drv:=mem[seg(sciezka_EXE):ofs(sciezka_EXE)+1] and $DF-ord('A');
     write('Checking '+Chr(drv+ord('A'))+': drive: ');
     asm                         { Sprawdza czy dysk jest CD-ROMem }
        push  ds
        push  es
        push  di
        mov   ax,150bh
        mov   cl,drv
        xor   ch,ch
        int   2fh
        pop   di
        pop   es
        pop   ds
        cmp   bx,0ADADh
        jnz   not_cdromed
        or    ax,ax
        jz    not_cdromed
        jmp   cdromed
     end;

     not_cdromed:
     write('not CD-ROMed,');

     asm                         { Sprawdza wymienno dysku }
        mov   ax,4408h
        mov   bl,drv
        inc   bl                 { Tu si liczy od 1. (0=actualny dysk) }
        xor   bh,bh
        int   21h
        or    ax,ax
        jz    removeable
        jmp   nonremoveable
     end;

     removeable:
     GameDrive:=FDD;
     WorkDir:=sciezka_EXE;            { Gdzie zapisywa CFG i SVEy }
     writeln(' removeable.');
     writeln('Temporary directory: ['+WorkDir+'].');
     exit;

     nonremoveable:
     GameDrive:=HDD;
     WorkDir:=sciezka_EXE;
     writeln(' non-removeable.');
     writeln('Temporary directory: ['+WorkDir+'].');
     exit;

     cdromed:
     GameDrive:=CD;
     WorkDir:=GetEnv('TEMP');
     writeln('CD-ROMed.');
     writeln('Temporary directory: ['+WorkDir+'].');
end;


procedure initgraph256; assembler;
asm
        mov     ax,0013h
        int     10h
end;

procedure clrscr(atr: byte); assembler;     { IN:  Atrybut }
asm
        mov     ax,0600h
        mov     bh,atr
        xor     cx,cx
        mov     dx,184fh
        int     10h
end;

procedure putchar(znak,atr: byte; ile: word); assembler;
asm
        mov     ah,0fh
        int     10h                         { Return in BH active page }

        mov     ah,09h
        mov     al,znak
        mov     bl,atr
        mov     cx,ile
        int     10h
end;

procedure GotoXY(x,y: byte); assembler;
asm
        mov     ah,0fh
        int     10h                         { Return in BH active page }

        mov     ah,02h
        mov     dh,y
        mov     dl,x
        int     10h
end;

procedure putstring(x,y,atr: byte; napis: string);
var s,o: word;
begin
s:=seg(napis);                  { Trzeba tak bo gnj (pascal) co le }
o:=ofs(napis);                  { podkada adres jak si robi w ASM.  }
asm
        mov     ah,0fh
        int     10h                         { Return in BH active page }

        push    es
        push    bp

        mov     dl,x
        mov     dh,y
        mov     bl,atr
        mov     es,s
        mov     bp,o
        xor     ch,ch
        mov     cl,byte ptr es:[bp]
        inc     bp
        mov     ax,1301h
        int     10h

        pop     bp
        pop     es
end;
end;



procedure clear_keyboard; assembler;
asm
@Czysc:
        mov     ah,11h              { IS keypressed ? }
        int     16h
        jz      @koniec

        mov     ah,10h              { Pressed }
        int     16h
        loop    @Czysc

@koniec:
end;

procedure Set_max_speed; assembler;
asm
        mov     al,0f3h
        out     60h,al
@wait:
        in      al,64h
        test    al,02h
        jnz     @wait

        xor     al,al
        out     60h,al
end;


function sqrt_int(w: word): word; assembler;
asm
        mov     ax,1
        mov     cx,[w]
        or      cx,cx
        jnz     @loopy
        xor     ax,ax
        jmp     @result_

@loopy:
        mov     bx,ax
        mov     ax,cx
        xor     dx,dx
        div     bx
        add     ax,bx
        shr     ax,1
        mov     dx,ax
        sub     dx,bx
        cmp     dx,1
        ja      @loopy

@result_:
end;


procedure setrgbpal(s,o:word); assembler;       { Set RGB palete colorow }
asm                                             { Proc zapisu palety RGB  }
        push    ds
        mov     ds,ss:s
        mov     si,ss:o

        mov     cx,256*3
        mov     dx,3c8h
        xor     al,al
        out     dx,al
        inc     dx
        cld
@petel:
        outsb
        loop    @petel
        pop     ds
end;

procedure getrgbpal(s,o:word); assembler;
asm                        { Proc odczyt palety RGB }
{        push    es
        mov     es,ss:s
        mov     di,ss:o
        mov     cx,256*3
        mov     dx,3c8h
        mov     ax,1
        out     dx,ax
        inc     dx
        cld
        rep     insb
        pop     es}
   mov  ax,1017h
   mov  es,s
   mov  dx,o
   xor  bx,bx
   mov  cx,$100
   int  10h
end;


procedure fade_down;
var   pal : array [1..769] of byte;
      i,j : word;
begin
GetRGBpal(seg(pal),ofs(pal));
For j:=1 to 63 do
    begin
         for i:=1 to 769 do
             if pal[i]<>0 then dec(pal[i]);
         Repeat Until port[$3da] and 8=8;      { Vertical return }
         SetRGBpal(seg(pal),ofs(pal));
    end;
end;

procedure fade_up(s,o: word);
var   pal  : array [1..769] of byte;
      i,j  : word;
begin
FillChar(pal,SizeOf(pal),#0);
For j:=1 to 63 do
    begin
         for i:=1 to 769 do
             begin
                  if pal[i]<mem[s:o+i-1] then Inc(pal[i])
                                       Else
                  if pal[i]>mem[s:o+i-1] then Dec(pal[i]);
             end;
         Repeat Until port[$3da] and 8=8;      { Vertical return }
         Repeat Until port[$3da] and 8=8;      { Vertical return }
         SetRGBpal(seg(pal),ofs(pal));
         Repeat Until port[$3da] and 8=8;      { Vertical return }
         Repeat Until port[$3da] and 8=8;      { Vertical return }
    end;
end;


(********************** Nakadanie textu ************************)
procedure put_char_XY(xp,yp: word; No,ch,col: byte; InPut: T_Font);
var   tym_ofs       : word;
      tym_add       : word;
      s_data,o_data : word;
      xmax,ymax     : word;
begin
      xmax:=InPut[no].Xmax;
      ymax:=InPut[no].Ymax;
      tym_ofs:=xp+320*yp;
      tym_add:=320-xmax;
      s_data:=Seg(InPut[no].Point^);
      o_data:=Ofs(InPut[no].Point^)+ch*Xmax*Ymax;

asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:
      push  cx

  @petla_X:
      lodsb                   { mov   al,ds:[si] & inc si }
      or    al,al
      jz    @go
      mov   al,ss:col
      stosb                   { mov   es:[di],al & inc di }
  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
  loop  @petla_X

@koniec:
      pop   cx
      add   di,ss:tym_add
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;


procedure put_string_XY(xp,yp: word; No : byte; napis: string; col: byte);
var   tym_ofs       : word;        {  ^ Nr czcionki       Color ^ }
      tym_add       : word;
      s_data,o_data : word;
      xmax,ymax     : word;
      i             : word;
begin
      IF Length(napis)=0 Then exit;
      xmax:=Font[no].Xmax;
      ymax:=Font[no].Ymax;
      tym_ofs:=xp+320*yp;
      tym_add:=320-xmax;
      s_data:=Seg(Font[no].Point^);

      i:=0;
      IF Font[No].Size<>0 Then          { Tzn e to nie ROMfont }
Repeat
      inc(i);
      o_data:=Ofs(Font[no].Point^)+mem[Seg(napis):Ofs(napis)+i]*Xmax*Ymax;
asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:
      push  cx

  @petla_X:
      lodsb
      or    al,al
      jz    @go
      mov   al,ss:col
      stosb

  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
  loop  @petla_X

@koniec:
      pop   cx
      add   di,ss:tym_add
      dec   dx
jne   @petla_Y
      pop   ds
end;
      tym_ofs:=tym_ofs+xmax;
until i=Length(napis)
      Else
Repeat
      inc(i);
      o_data:=Ofs(Font[no].Point^)+mem[Seg(napis):Ofs(napis)+i]*Ymax;
asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:

      lodsb
      mov   ah,al
      push  cx
      mov   bx,1
      shl   bx,cl
      shl   bx,1
      mov   al,ss:col
  @petla_X:
      shr   bx,1
      test  ah,bl
      jz    @go
      stosb
  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
  loop  @petla_X

@koniec:

      pop   cx
      add   di,ss:tym_add
      dec   dx
jne   @petla_Y
      pop   ds
end;
      tym_ofs:=tym_ofs+xmax;
until i=Length(napis)
end;


procedure put_string_shadow(xp,yp: word; No : byte; napis: string; col1,col2: byte);
begin
Put_String_XY(xp-1,yp-1,No,napis,col2);
Put_String_XY(xp-1,yp+1,No,napis,col2);
Put_String_XY(xp+1,yp-1,No,napis,col2);
Put_String_XY(xp+1,yp+1,No,napis,col2);
Put_String_XY(xp-1,yp,No,napis,col2);
Put_String_XY(xp+1,yp,No,napis,col2);
Put_String_XY(xp,yp-1,No,napis,col2);
Put_String_XY(xp,yp+1,No,napis,col2);
Put_String_XY(xp,yp,No,napis,col1);
end;


procedure Load_Font(font_name: string);
Type      T_font    = record
                       ID    :  String[10];
                       info  :  String[20];
                       count :  byte;
                       xmax,
                       ymax  :  word;
                      end;
Var       f     : file;
          tym   : T_Font;
          count : word;
          no    : byte;
begin
     write('Loading font [',font_name,']... ');
     for no:=1 to 100 do IF Font[no].Used=False Then begin count:=no; break end;
     FileMode:=0;                      { Read-Only }
     Assign(f,font_name);
     Reset(f,1);
     Check4Error(font_name);
     BlockRead(f,tym,SizeOF(T_Font));
     IF Tym.ID <> 'PS-font   ' Then
        begin
             Txt_Mode;
             Writeln(#13,#10,'FATAL: File [',font_name,'] is invalid.');
             Halt;
        end;
     Check4Error(font_name);
     Font[no].Count:=Tym.Count;
     count:=Tym.Count;                    { Bo liczone od Zera }
     Font[no].Xmax:=Tym.Xmax;
     Font[no].Ymax:=Tym.Ymax;
     Font[no].Size:=Count*Tym.Xmax*Tym.Ymax;
     Font[no].Used:=True;
     Font[no].Point:=Reserve_Mem(Count*Tym.Xmax*Tym.Ymax);
     BlockRead(f,Font[no].Point^,Count*Tym.Xmax*Tym.Ymax);
     Check4Error(font_name);
     Close(F);
     writeln('ok.');
end;


procedure load_ROM_fonts;
Var       count : word;
          no    : byte;

Function GetROMFontPointer(no: byte): Pointer;    { No - Numer czcionki }
var      s,o : word;
begin
     asm
        push    bp
        push    es

        mov     ax,1130h
        mov     bh,no
        int     10h
        mov     ax,es
        mov     bx,bp

        pop     es
        pop     bp

        mov     s,ax                  { Adres gdzie skadowane s czcionki }
        mov     o,bx
     end;
     GetROMFontPointer:=Ptr(s,o);
end;

begin
     write('Looking for ROM-font 8x8... ');
     for no:=1 to 100 do IF NOT Font[no].Used Then begin count:=no; break end;
     no:=count;                     { Znalezienie pierwszego wolnego }
     Font[no].Count:=128;
     Font[no].Xmax:=8;
     Font[no].Ymax:=8;
     Font[no].Size:=0;              { Take oznaczenie e to ROM-font }
     Font[no].Used:=True;
     Font[no].Point:=GetROMfontPointer(3); { Czcionka 8x8 0-128 }
     if Font[no].Point=nil then WriteExitMsg('ROM-Font does not exist.');
     writeln('ok.');

     write('Looking for ROM-font 8x16... ');
     for no:=1 to 100 do IF NOT Font[no].Used Then begin count:=no; break end;
     no:=count;                     { Znalezienie pierwszego wolnego }
     Font[no].Count:=255;
     Font[no].Xmax:=8;
     Font[no].Ymax:=16;
     Font[no].Size:=0;              { Take oznaczenie e to ROM-font }
     Font[no].Used:=True;
     Font[no].Point:=GetROMfontPointer(6); { Czcionka 8x16 0-255 }
     if Font[no].Point=nil then WriteExitMsg('does not exist.');
     writeln('ok.');
end;

procedure WriteMSG(txt: string);
const x    : word = 1;
      y    : word = 1;
      wys  : byte = 6;
var   save : word;
begin
     if NOT ShowMSGs then exit;
     if Is_txtmode then writeln(txt)
        else
     begin
          save:=s_virt;
          s_virt:=SegA000;
          put_string_shadow(x,y,4,txt,TxtCol_1st,TxtCol_2nd);
          inc(y,wys);
          if y>200-wys then y:=1;
          s_virt:=save;
     end;
end;

end.