(*
        SpaceSweeper mouse helper 
        Writen in asm, using 13th int - mouse management

        Author: Piotr Skowronek, pskowronek@adfinem.net
        Written in: 1997
        Licence: LGPL
 *)

(*************************************************
**************************************************)
unit MOUSE;
interface

type T_Button = (Left,Right,Central);
     T_Mouse  = object
                       x,y     : word;
                       ButtonL : word;
                       ButtonR : word;
                       ButtonC : word;
                       Buttons : word;
                       xL,yL   : word;
                       xR,YR   : word;
                       xC,yC   : word;
                       PressL  : word;
                       PressR  : word;
                       PressC  : word;
                       xpL,ypL : word;
                       xpR,ypR : word;
                       xpC,ypC : word;
                       function  init: boolean;
                       procedure hide;
                       procedure show;
                       procedure install;
                       procedure remove;
                       function  GetPressPos(Button: T_Button; xm,ym: word): word;
                       procedure GetMousePos(xm,ym: word);
                       function  GetMouseStatus(Button: T_Button; xm,ym: word): word;
                       function  PressIn(button: word; var xp,yp,stan: word): word;
                       function  PressOut(button: word; var xp,yp,stan: word): word;
                       procedure GetXY(var xp,yp,stan: word);
                       procedure SetXY(xp,yp : word);
                private
                       Old_Ofs : word;
                       Old_Seg : word;
                       Type_Ev : word;
               end;

var  Mouse_Event : T_Mouse;

(******  Uywajce INT 33h do odczytu pozycji  ******)



implementation


procedure my_handler; Far;
assembler;

{ Uaktualnia tablic "Mouse_Event" wartociami pozycji
  nacinicia przyciskw.                             }

asm
   push  ds
   push  es
   mov   ax,seg Mouse_Event
   mov   ds,ax

   mov   Mouse_Event.X,cx
   mov   Mouse_Event.Y,dx
   mov   Mouse_Event.Buttons,bx

   test  bx,01h
   jz    @nie_01
   inc   Mouse_Event.ButtonL
   mov   Mouse_Event.xL,cx
   mov   Mouse_Event.yL,dx
   inc   Mouse_Event.PressL
   mov   Mouse_Event.xpL,cx
   mov   Mouse_Event.ypL,dx
   jmp   @prawy
@nie_01:
   mov   Mouse_Event.ButtonL,0
   mov   Mouse_Event.PressL,0

@prawy:
   test  bx,02h
   jz    @nie_02
   inc   Mouse_Event.ButtonR
   mov   Mouse_Event.xR,cx
   mov   Mouse_Event.yR,dx
   inc   Mouse_Event.PressR
   mov   Mouse_Event.xpR,cx
   mov   Mouse_Event.ypR,dx
   jmp   @centr
@nie_02:
   mov   Mouse_Event.ButtonR,0
   mov   Mouse_Event.PressR,0

@centr:
   test  bx,04h
   jz    @nie_03
   inc   Mouse_Event.ButtonC
   mov   Mouse_Event.xC,cx
   mov   Mouse_Event.yC,dx
   inc   Mouse_Event.PressC
   mov   Mouse_Event.xpC,cx
   mov   Mouse_Event.ypC,dx
   jmp   @dalej
@nie_03:
   mov   Mouse_Event.ButtonC,0
   mov   Mouse_Event.PressC,0

@dalej:
   pop   es
   pop   ds
end;



procedure T_Mouse.Install;
assembler;

{ Procedura podczepia funkcj 14h przerwania 33h
  procedur ("moja_obsuga") asynchronicznej obsugi
  zdarze ktra bdzie sama uaktalnia odpowiednio tablic }


asm
   push  ds
   mov   ax,seg Mouse_Event
   mov   ds,ax

   mov   ax,14h
   mov   cx,0ffffh
   mov   dx,seg My_Handler
   mov   es,dx
   mov   dx,offset My_Handler
   int   33h
   mov   Mouse_Event.Type_Ev,cx
   mov   Mouse_Event.Old_Ofs,dx
   mov   Mouse_Event.Old_Seg,es
   pop   ds
end;


procedure T_Mouse.Remove;
assembler;

{ Przywraca poprzedni proc. asynchronicznej obsugi zdarze }

asm
   push  ds
   mov   ax,seg Mouse_Event
   mov   ds,ax

   mov   cx,Mouse_Event.Type_Ev
   mov   dx,Mouse_Event.Old_Ofs
   mov   es,Mouse_Event.Old_Seg
   mov   ax,14h
   int   33h
   pop   ds
end;


procedure T_Mouse.Hide; assembler;                          { <--- Ukrycie }
asm
   mov   ax,02h
   int   33h
end;


procedure T_Mouse.Show; assembler;                          { <----- Poka }
asm
   mov   ax,01h
   int   33h
end;


function T_Mouse.GetPressPos(Button: T_Button; xm,ym: word): word;
begin
     case button of
      left:    begin
                 xm:=xpL;
                 ym:=ypL;
                 GetPressPos:=PressL;
                 PressL:=0;
               end;
      right:   begin
                 xm:=xpR;
                 ym:=ypR;
                 GetPressPos:=PressR;
                 PressR:=0;
               end;
      central: begin
                 xm:=xpC;
                 ym:=ypC;
                 GetPressPos:=PressC;
                 PressC:=0;
               end;
     end;
end;

procedure T_Mouse.GetMousePos(xm,ym: word);
begin
     xm:=x;
     ym:=y;
end;


function  T_Mouse.GetMouseStatus(Button: T_Button; xm,ym: word): word;
begin
     case button of
      left:    begin
                 xm:=xL;
                 ym:=yL;
                 GetMouseStatus:=ButtonL;
                 ButtonL:=0;
               end;
      right:   begin
                 xm:=xR;
                 ym:=yR;
                 GetMouseStatus:=ButtonR;
                 ButtonR:=0;
               end;
      central: begin
                 xm:=xC;
                 ym:=yC;
                 GetMouseStatus:=ButtonC;
                 ButtonC:=0;
               end;
     end;
end;




(******* Uywaj funkcji INT 33h ********)
Function T_Mouse.Init: boolean; assembler;                 { <- Init mousa }
asm
   xor   ax,ax      { Init }
   int   33h
   cmp   ax,0ffffh  { =-1  }
   jz    @jest
   mov   ax,0       { Niema }
   jmp   @wyjscie
@jest:
   mov   ax,1
@wyjscie:
end;


function T_Mouse.PressIn(button: word; var xp,yp,stan: word): word;
assembler;
{ Func odczytuje poozenie myszy po }
{ odciniciu, i czy nacinito.    }
asm
   mov   ax,05h
   mov   bx,button
   int   33h
   les   di,[xp]
   mov   es:[di],cx            { X }
   les   di,[yp]
   mov   es:[di],dx            { Y }
   les   di,[stan]
   mov   es:[di],ax            { Stan }
   mov   ax,bx                 { Ilo }
end;


function T_Mouse.PressOut(button: word; var xp,yp,stan: word): word;
assembler;
{ Func zapisuje polozenie myszy po }
{ odciniciu, i czy nacinito    }
asm
   mov   ax,06h
   mov   bx,button
   int   33h
   les   di,[xp]
   mov   es:[di],cx            { X }
   les   di,[yp]
   mov   es:[di],dx            { Y }
   les   di,[stan]
   mov   es:[di],ax            { Stan }
   mov   ax,bx                 { Ilo }
end;

procedure T_Mouse.GetXY(var xp,yp,stan: word);      { Odczyt pozycji mousa }
assembler;
asm
   mov   ax,03h
   int   33h
   les   di,[xp]
   mov   es:[di],cx            { X }
   les   di,[yp]
   mov   es:[di],dx            { Y }
   les   di,[stan]
   mov   es:[di],dx            { Stan }
end;

procedure T_Mouse.SetXY(xp,yp : word);           { Ustawienie poz na cx,dx }
assembler;
asm
   mov   ax,04h
   mov   cx,xp
   mov   dx,yp
   int   33h
end;


end.