(*
        SpaceSweeper types declarations
        Containts all classes used in game to represent
        objects such as ships, rockets, etc.

        Author: Piotr Skowronek, pskowronek@adfinem.net
        Written in: 1997
        Licence: LGPL
 *)

Unit Types;      { Dostosowany do GRY - Space Sweeper }
{$I-,R-,G+,S-,D+,Q-,V-,B-}
interface        { TYPE service }
Type
     bufor  = array [1..$FFFF] of byte;           { Do wczytywania BMP }
     paleta = array [1..256] of record r,g,b : byte; end;  { Na palet }
     dword = longint;
     st2   = string[2];
     BMP_File_Hdr_Type = record                      { *** BMP Header *** }
                           bfType    : word;         { 'BM' }
                           bfSize    : dword;        { Wiel caego BMP }
                           bfReserve1,
                           bfReserve2: word;
                           bfOFFBits : dword;        { Offset do danych }
                         end;
     BMP_Info_Hdr_Type = record                      {  *** BMP info ***  }
                           biSize    : dword;        { const 40 }
                           biWidth   : dword;        { Szeroko }
                           biHeight  : dword;        { Wysoko }
                           biPlanes  : word;         { Paty }
                           biBitCount: word;         { Bit na Pixel }
                           biCompression   : dword;  { 0 = w/o compresji }
                           biSizeImage     : dword;  { Wiel danych }
                           biXPelsPerMeter : dword;
                           biYPelsPerMeter : dword;
                           biClrUsed       : dword;
                           biClrImportant  : dword;
                         end;

     P_BMP_Sprite = ^T_BMP_Sprite;
     T_BMP_Sprite = record
                          xmax,
                          ymax : word;        { Max X i Max Y BitMap'y }
                          size : word;   { Ilo przydzielonej pamici }
                          pal_exist : boolean;     { Czy paleta jest ? }
                          pal  : ^paleta;   { IF Thus to wsk do palety }
                          data : ^bufor;          { Wskanik do danych }
                    end;

(************* PAK header ***************)
     P_Header    = ^T_Header;
     T_Header    = record
                         ID           : array[1..30] of char;
                   end;

     T_Fire      = record
                         x1,y1,x2,y2 : word;
                         Able        : boolean;
                         Aim         : boolean;
                         Power       : word;
                   end;

     P_Image     = ^T_Image;
     T_Image     = record
                        img    : T_BMP_Sprite;
                        Next   : P_Image;
                   end;

     P_Images    = ^T_Images;
     T_Images    = record
                         Score   : word;       { Score for shot-down }
                         Defense : word;       { How many shots to kill }
                         Bonus   : word;       { If killed then bonus ? =0 no }
                         Fire    : T_Fire;     { Fire info (pos) }
                         Image   : P_Image;    { Pointer to frames }
                         Next    : P_Images;   { Pointer to next image }
                   end;

     P_Kit       = ^T_Kit;
     T_Kit       = record
                         Alians   : P_Images;
                         Explodes : P_Images;
                         Fighters : P_Images;
                         Cockpit  : P_Images;
                         Scene    : P_Images;
                         Colors   : P_Images;
                         Next     : P_Kit;
                   end;

(********************************************************************)
     P_Resource  = ^T_Resource;
     T_Resource  = record
                         Head     : T_Header;
                         ImageKit : P_Kit;
                         Episodes : Pointer;
                   end;
(********************************************************************)

     P_Explode   = ^T_Explode;
     T_Explode   = record                     { Explode na gwiazdy }
                        xpos,ypos : integer;     { Pocztkowa pozycja wybuchu }
                        add,accel : word;        { Add - przemieszczenie }
                        TheEnd    : byte;        { Ile jeszcze gwiazd w locie }
                        explode   : array[1..50] of
                                         record
                                             kat,odl : word;
                                             max     : byte;  { Max odl }
                                         end;
                   end;


     P_Intro     = ^T_Intro;
     T_Intro     = record
                         size     : word;
                         Text     : ^bufor;
                         Image    : P_Image;
                   end;

     T_Fly_Case  = record
                         sinx   : integer;
                         siny   : integer;
                         horiz  : integer;
                         vert   : integer;
                         clip   : boolean;
                         defense: word;       { How many shots to kill }
                         which  : word;       { Ktra BitMapa w KIT }
                         point  : p_images;   { Ust. w grze bezp dost. /\ }
                   end;

     T_Crash_Case = record       { Na wypadek katastrofy corobi }
                         How    : (stars,stars_image,image,nothing);
                         Explode     : p_explode;  { Przy wybuchu ustawiany }
                         which       : word;       { If si rozwali to jak wybuch }
                         point       : p_images;   { Ust. w grze bezp dost. }
                    end;

     P_ShipsPos  = ^T_ShipsPos;
     T_ShipsPos  = record        { w sumie ok. 30B na jeden statek }
                         What        : (flying,dieing,dead);
                         x,y         : word;       { Ostatnia pozycja }
                         Fly_Case    : T_Fly_Case; { Jak si ma porusza }
                         Crash_Case  : T_Crash_Case; { How to explode }
                         FireAble    : boolean;    { czy ma strzela }
                         Bonus       : word;       { =0 no bonus }
                         frame,delay : byte;       { do animacji (opnienie) }
                         Next        : P_ShipsPos; { Next Alian }
                   end;

     P_Levels    = ^T_Levels;
     T_Levels    = record         { level'e }
                         ShipsPos : P_ShipsPos;    { "tablica" pos statkw }
                         WhichKit : word;          { Ktry zestaw img'w }
                         MaxShips : word;          { Ilo statkw w "tablicy" }
                         MaxPos   : word;          { Dugo drogi }
                         Intro    : P_Intro;       { Wprowadzenie }
                         Title    : string[50];    { Tytu level'a }
                         Next     : P_Levels;      { Nastpny level }
                   end;

(*********************************************************************)
     P_Episodes  = ^T_Episodes;
     T_Episodes  = record         { Episody z level'ami }
                         Levels   : P_Levels;      { Grupa leveli }
                         Intro    : P_Intro;       { Wprow. do episodu }
                         Title    : string[50];    { Tytu episodu }
                         Skill    : array [1..3] of string[50]; { Nazwy poziomw trudnoci }
                         Next     : P_Episodes;    { Next episode }
                   end;
(*********************************************************************)

     T_font     = array [1..10] of
                  record
                        used      : boolean;     { Is used ? }
                        count     : byte;        { Chyba Max ilo liter }
                        xmax,ymax : word;        { Wys. & Szer. liter }
                        size      : word;        { Wielko pamici dla point }
                        point     : pointer;     { pointer to font }
                  end;



const Yes = True;
      No  = False;
      ID  : PChar = 'Space Sweeper''s data file !';
      GameDrive : (CD,HDD,FDD) = HDD;
      WorkDir   : string[80] = '';
      ShowMSGs  : boolean = true;

var  Black,Blue,Green,Cyan,Red,Magenta,Brown,LightGray, { kolory }
     DarkGray,LightBlue,LightGreen,LightCyan,LightRed,
     LightMagenta,Yellow,White,TxtCol_1st,TxtCol_2nd  :  byte;
     s_virt,o_virt   : word;                { Na seg i ofs roboczego }
     font            : T_font;              { Czcionki               }

implementation

end.